#!/bin/bash
# /etc/rc.d/init.d/camlgrenouille
#
# Fichier de lancement de camlgrenouille au demarrage de GNU/Linux
#
# Realise par Loic Prouveze, le 24 mars 2003

# chkconfig: 2345 96 16
# description: Dmarrage de CamlGrenouille

#debug
#set -x

DAEMON=/usr/local/bin/camlgrenouille/camlgrenouille
initdir=/etc/rc.d/init.d

PATH=/sbin:/usr/sbin:/bin:/usr/bin
export PATH



# Status

function status()
{
 ps axwww|grep "[0-9]:[0-9][0-9] $DAEMON" | (
 while read pid tt stat time command; do echo $command; done
 )
}

# Renvoie true s'il y a au moins un pid existant

function alive()
 {
 if [ -z "$*" ]; then
 return 1
 fi
 for i in $*; do
 if kill -0 $i 2> /dev/null; then
 return 0
 fi
 done

return 1
 }

# start/stop function

function start()
 {
 RETVAL=0
 # Verification que CamlGrenouille ne soit pas deja lance
 if [ ! -f /var/lock/subsys/camlgrenouille ]; then
 echo ''
 echo 'Starting CamlGrenouille...'
 echo ''
 /usr/local/bin/camlgrenouille/camlgrenouille -f echo ' (then Ctrl+C when you fed up with it !) '
 echo ''
 echo ''
 echo
 touch /var/lock/camlgrenouille
 fi
 return $RETVAL
 }

function stop()
 {
 echo ''
 echo -n "Stopping CamlGrenouille..."
 echo ''
 pids=$(/sbin/pidof $DAEMON)
 kill -TERM $pids 2> /dev/null && sleep 1
 RETVAL=$?
 count=1
 while alive $pids; do
 sleep 5
 count=$(expr $count + 1)
 if [ $count -gt 10 ]; then
 echo "Arret de CamlGrenouille"
 break;
 fi
 echo "CamlGrenouille n'est pas encore arrete : nouvel essais...
(attempt
 $count)"
 done
 echo
 rm -f /var/lock/subsys/camlgrenouille
 rm -f /var/log/camlgrenouille
 return $RETVAL
 }

# See how we were called.

case "$1" in
 start)
 start
 ;;
 stop)
 stop
 ;;
 reload|restart)
 if [ ! -f /var/lock/subsys/camlgrenouille ]; then
 echo "CamlGrenouille n'est pas en cours de fonctionnement."
 exit 1
 fi
 echo ''
 echo "Verification des changements de /etc/grenouille.conf ...."
 if [ -f /var/lock/camlgrenouille ] ; then
 stop
 start
 fi
 ;;
 status)
 status
 ;;
 *)
 echo "Usage: $initdir/camlgrenouille
 {start|stop|restart|reload|status}"
 exit 1
 esac

exit 0

/etc/camlgrenouille.conf \
 1>> /var/log/camlgrenouille \
 2>> /var/log/messages &

sleep 1
 /bin/cat /var/log/camlgrenouille
 echo ''
 echo ' To see results :'
 echo ''
 echo ' do "cat /var/log/camlgrenouille" '
 echo ' or "tail -f /var/log/camlgrenouille" '

